import type { Static } from "@sinclair/typebox"
import type { FastifyReply, FastifyRequest } from "fastify"
import { PluginFastifyInstance } from "types"
import { Type } from "@sinclair/typebox"

const permissions = ["user.isAdmin"]

const ParamsSchema = Type.Object({
  _id: Type.String(),
})
type Params = Static<typeof ParamsSchema>

export default (fastify: PluginFastifyInstance) => {
  const userService = fastify.custom.userService

  const handler = async (
    req: FastifyRequest<{ Params: Params }>,
    reply: FastifyReply,
  ) => {
    try {
      const { _id } = req.params

      const payloadWithUser = await userService.hardDeleteUser(
        fastify,
        req.requestParams,
        _id,
      )

      return payloadWithUser
    } catch (error: any) {
      fastify.log.error(error.message)
      return reply.internalServerError(error.message)
    }
  }

  return {
    handler,
    onRequest: [fastify.authenticate, fastify.checkPermissions(permissions)],
    config: {
      type: "dataHardDeleted",
      broadcastChannels: ["userHardDeleted"],
    },
    schema: {
      summary: "Permanently delete a user by id",
      description: "Hard delete a user",
      tags: ["core/user"],
      params: ParamsSchema,
    },
  }
}
